Index: include/asterisk/lock.h
===================================================================
--- include/asterisk/lock.h	(revision 89037)
+++ include/asterisk/lock.h	(working copy)
@@ -74,9 +74,13 @@
 #define AST_PTHREADT_NULL (pthread_t) -1
 #define AST_PTHREADT_STOP (pthread_t) -2
 
-#if defined(SOLARIS) || defined(BSD)
-#define AST_MUTEX_INIT_W_CONSTRUCTORS
-#endif /* SOLARIS || BSD */
+/* I found, that PTHREAD_MUTEX_INITIALIZER is NULL in NetBSD, OpenBSD, FreeBSD
+ * and, may be, in others OS (need testing) 
+ * PTHREAD_MUTEX_INITIALIZER is structure in Linux,Solaris,OS/X, etc..
+ */
+#if defined(__NetBSD__) || defined(__OpenBSD__) || defined(__FreeBSD__) 
+#define AST_MUTEX_INIT_W_CONSTRUCTORS 
+#endif /* NetBSD, OpenBSD, FreeBSD */
 
 /* Asterisk REQUIRES recursive (not error checking) mutexes
    and will not run without them. */
